Package nl.tudelft.simulation.dsol.animation.gis.map

## Class Feature

- java.lang.Object
- - nl.tudelft.simulation.dsol.animation.gis.map.Feature

All Implemented Interfaces:
  `Serializable`, `FeatureInterface`

    public class Feature
    extends Object
    implements FeatureInterface

Feature contains an element of a layer, defined by a key value combination, with its own colors.
TODO: minimum scale and maximum scale to draw features has to be added again, but first, scale needs to be defined properly.

Copyright (c) 2021-2021 Delft University of Technology, Jaffalaan 5, 2628 BX Delft, the Netherlands. All rights reserved. See for project information DSOL Manual. The DSOL project is distributed under a three-clause BSD-style license, which can be found at DSOL License.

Author:
  Alexander Verbraeck
See Also:
  Serialized Form

### Constructor Summary

Constructors
`Feature()`

### Method Summary

All Methods Instance Methods Concrete Methods
`Color` `getFillColor()`
`String` `getKey()`
`int` `getNumShapes()`
`Color` `getOutlineColor()`
`GisObject` `getShape​(int index)`
`List<GisObject>` `getShapes()`
`List<GisObject>` `getShapes​(Bounds2d rectangle)`
`String` `getValue()`
`boolean` `isInitialized()`
`void` `setFillColor​(Color fillColor)`
`void` `setInitialized​(boolean initialized)`
`void` `setKey​(String key)`
`void` `setOutlineColor​(Color outlineColor)`
`void` `setValue​(String value)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### Feature

    public Feature()

### Method Detail

#### getKey

    public final String getKey()

Specified by:
  `getKey` in interface `FeatureInterface`

#### setKey

    public final void setKey​(String key)

Specified by:
  `setKey` in interface `FeatureInterface`

#### getValue

    public final String getValue()

Specified by:
  `getValue` in interface `FeatureInterface`

#### isInitialized

    public boolean isInitialized()

Specified by:
  `isInitialized` in interface `FeatureInterface`

#### setInitialized

    public void setInitialized​(boolean initialized)

Specified by:
  `setInitialized` in interface `FeatureInterface`

#### getNumShapes

    public int getNumShapes()

Specified by:
  `getNumShapes` in interface `FeatureInterface`

#### getShape

    public GisObject getShape​(int index)
                       throws IndexOutOfBoundsException

Specified by:
  `getShape` in interface `FeatureInterface`
Throws:
  `IndexOutOfBoundsException`

#### getShapes

    public List<GisObject> getShapes()

Specified by:
  `getShapes` in interface `FeatureInterface`

#### getShapes

    public List<GisObject> getShapes​(Bounds2d rectangle)

Specified by:
  `getShapes` in interface `FeatureInterface`

#### setValue

    public final void setValue​(String value)

Specified by:
  `setValue` in interface `FeatureInterface`

#### getFillColor

    public Color getFillColor()

Specified by:
  `getFillColor` in interface `FeatureInterface`

#### setFillColor

    public void setFillColor​(Color fillColor)

Specified by:
  `setFillColor` in interface `FeatureInterface`

#### getOutlineColor

    public Color getOutlineColor()

Specified by:
  `getOutlineColor` in interface `FeatureInterface`

#### setOutlineColor

    public void setOutlineColor​(Color outlineColor)

Specified by:
  `setOutlineColor` in interface `FeatureInterface`